/*
 * tsl2569.h
 *
 *  Created on: 11.01.2019
 *      Author: PLARZAW1
 */

#ifndef DEVICES_INC_TSL2569_H_
#define DEVICES_INC_TSL2569_H_

#include "../../../Utilities/Inc/errors.h"
#include "ic_devices.h"


//COMMAND
	#define TSL2569_REG_MASK__COMMAND__CMD 			  			0x80
	#define TSL2569_REG_VALUE__COMMAND__CMD__ENABLE 			0x80

	#define TSL2569_REG_MASK__COMMAND__CLEAR 		  			0x40
	#define TSL2569_REG_VALUE__COMMAND__CLEAR__ENABLE 			0x40
	#define TSL2569_REG_VALUE__COMMAND__CLEAR__DISABLE 			0x00

	#define TSL2569_REG_MASK__COMMAND__WORD 		  			0x20
	#define TSL2569_REG_VALUE__COMMAND__WORD__ENABLE 			0x20
	#define TSL2569_REG_VALUE__COMMAND__WORD__DISABLE 			0x00

	#define TSL2569_REG_MASK__COMMAND__BLOCK 		  			0x10
	#define TSL2569_REG_VALUE__COMMAND__BLOCK__ENABLE 			0x10
	#define TSL2569_REG_VALUE__COMMAND__BLOCK__DISABLE 			0x00

	#define TSL2569_REG_MASK__COMMAND__ADDRESS 		  			0x0F


#define TSL2569_REG_ADDR__CONTROL 								0x00

	#define TSL2569_REG_MASK__CONTROL__POWER 		  			0x03
	#define TSL2569_REG_VALUE__CONTROL__POWER__POWERUP 			0x03
	#define TSL2569_REG_VALUE__CONTROL__POWER__POWERDOWN		0x00

#define TSL2569_REG_ADDR__TIMING 								0x01

	#define TSL2569_REG_MASK__TIMING__GAIN	 		  			0x10
	#define TSL2569_REG_VALUE__TIMING__GAIN__HIGH 				0x10
	#define TSL2569_REG_VALUE__TIMING__GAIN__LOW				0x00

	#define TSL2569_REG_MASK__TIMING__MANUAL 		  			0x08
	#define TSL2569_REG_VALUE__TIMING__MANUAL__START			0x08
	#define TSL2569_REG_VALUE__TIMING__MANUAL__STOP				0x00

	#define TSL2569_REG_MASK__TIMING__INTEG 		  			0x03
	#define TSL2569_REG_VALUE__TIMING__INTEG__13MS				0x00
	#define TSL2569_REG_VALUE__TIMING__INTEG__101MS				0x01
	#define TSL2569_REG_VALUE__TIMING__INTEG__402MS				0x02

#define TSL2569_REG_ADDR__THRESHLOW_LOW							0x02
#define TSL2569_REG_ADDR__THRESHLOW_HIGH						0x03
#define TSL2569_REG_ADDR__THRESHHIGH_LOW						0x04
#define TSL2569_REG_ADDR__THRESHHIGH_HIGH						0x05

#define TSL2569_REG_ADDR__INTERRUPT								0x06

	#define TSL2569_REG_MASK__INTERRUPT__INTR 		  			0x30
	#define TSL2569_REG_VALUE__INTERRUPT__INTR__DISABLED		0x00
	#define TSL2569_REG_VALUE__INTERRUPT__INTR__LEVEL			0x10
	#define TSL2569_REG_VALUE__INTERRUPT__INTR__SMBALERT		0x20
	#define TSL2569_REG_VALUE__INTERRUPT__INTR__TEST			0x30

	#define TSL2569_REG_MASK__INTERRUPT__PERSIST	  			0x0F
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__EVERY		0x00
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__ANY			0x01
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__2			0x02
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__3			0x03
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__4			0x04
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__5			0x05
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__6			0x06
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__7			0x07
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__8			0x08
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__9			0x09
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__10			0x0A
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__11			0x0B
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__12			0x0C
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__13			0x0D
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__14			0x0E
	#define TSL2569_REG_VALUE__INTERRUPT__PERSIST__15			0x0F

#define TSL2569_REG_ADDR__CRC									0x08

#define TSL2569_REG_ADDR__ID									0x0A	//value=0xB.

	#define TSL2569_REG_MASK__ID__PARTNO			  			0xF0
	#define TSL2569_REG_MASK__ID__REVNO				  			0x0F

#define TSL2569_REG_ADDR__DATA0_LOW								0x0C
#define TSL2569_REG_ADDR__DATA0_HIGH							0x0D
#define TSL2569_REG_ADDR__DATA1_LOW								0x0E
#define TSL2569_REG_ADDR__DATA1_HIGH							0x0F




err_code_t tsl2569_Init(ic_address_t device);
err_code_t tsl2569_WhoAmI(ic_address_t device);
err_code_t tsl2569_ReadLight(ic_address_t device, uint16_t *value_all, uint16_t *value_ir);



#endif /* DEVICES_INC_TSL2569_H_ */
